10 ! *****************************************
20 ! *               ABC2048                 *
30 ! * Programmerat av Mattias Eriksson 2018 *
40 ! *           Version 180205              *
50 ! * Spelprogrammet {r {mnat f|r ABC 806   *
60 ! *****************************************
100 INTEGER : EXTEND : RANDOMIZE : ATTRIBUTE 1
110 ! *** INITIERA: ***
120 DIM Spelplan(3,3), Temprad(3)
130 Flyttat=0 : Po{ng=0 : Riktning = 0
140 FGCTL BLK+RED+MAG+BLU
150 Z=FNClr
160 Z=FNSlumpa : Z=FNSlumpa
170 ; CUR(17,32) DBLE CYA "ABC 2048"
180 ; CUR(21,15) GRN "Instruktioner: Styr med 8,4,5,6. Q - Avsluta spelet."
190 ; CUR(22,17) GRN "M}let med spelet {r att f} 2048 i en av rutorna."
200 ; CUR(24,20) RED "Programmerat av Mattias Eriksson feb 2018"
210 Z=FNRitaspelplan
220 Z=FNRam
230 ! *** HUVUDLOOP: ***
240 Riktning = 0
250 ; CUR(18,34) "Po{ng:";Po{ng
260 ; CUR(0,0)
270 GET Drag$
280 IF Drag$="8" THEN Riktning=1
290 IF Drag$="4" THEN Riktning=2
300 IF Drag$="5" THEN Riktning=3
310 IF Drag$="6" THEN Riktning=4
320 IF Drag$="q" OR Drag$="Q" THEN 9000
330 IF Riktning>0 THEN Z=FNDrag
340 GOTO 240
350 ! *** FUNKTIONER ***
1000 ! *** Slumpa: ***
1010 DEF FNSlumpa
1020   X=3*RND : Y=3*RND
1030   IF Spelplan(Y,X)<>0 THEN 1020
1040   IF 3*RND<3 THEN Spelplan(Y,X)=2 ELSE Spelplan(Y,X)=4
1050   RETURN 0
1060 FNEND
2000 ! *** Rita spelplan: ***
2010 DEF FNRitaspelplan
2020   FOR Y=0 TO 3
2030     Sy=1+Y*4
2040     FOR X=0 TO 3
2050       V=Spelplan(Y,X) : Sx=10+X+(X*15)
2060       IF V=0 OR Storflytt=1 THEN ; CUR(Sy,Sx) DBLE "     "
2070       IF V=2 THEN ; CUR(Sy,Sx) DBLE WHT V
2080       IF V=4 THEN ; CUR(Sy,Sx) DBLE YEL V
2090       IF V=8 OR V=512 THEN ; CUR(Sy,Sx) DBLE MAG V
2100       IF V=16 OR V=256 THEN ; CUR(Sy,Sx) DBLE GRN V
2110       IF V=32 OR V=1024 THEN ; CUR(Sy,Sx) DBLE CYA V
2120       IF V=64 THEN ; CUR(Sy,Sx) DBLE RED V
2130       IF V=128 THEN ; CUR(Sy,Sx) DBLE BLU V
2150       IF V>2047 THEN ; CUR(Sy,Sx) DBLE FLSH GRN V
2160     NEXT X
2170   NEXT Y
2180   Storflytt=0
2190   RETURN 0
2200 FNEND
3000 ! *** Flytta: ***
3010 DEF FNFlytta
3020   FOR I=0 TO 2
3030     IF Temprad(I)=0 AND Temprad(I+1)>0 THEN I=FNFlyttatal
3040   NEXT I
3050   RETURN 0
3100 FNEND
3500 DEF FNFlyttatal
3510   Temprad(I)=Temprad(I+1)
3520   Temprad(I+1)=0
3530   Flyttat=1
3540   IF Temprad(I)>99 THEN Storflytt=1
3550   RETURN 0
3560 FNEND
4000 ! *** Sl} ihop: ***
4010 DEF FNSl}Ihop
4020   FOR I=0 TO 2
4040     IF Temprad(I)<>0 AND Temprad(I)=Temprad(I+1) THEN Flyttat=FNSl}ihoptal
4050   NEXT I
4060   RETURN 0
4070 FNEND
4500 DEF FNSl}ihoptal
4510   Temprad(I)=2*Temprad(I)
4520   Po{ng=Po{ng+Temprad(I)
4530   Temprad(I+1)=0
4540   IF Temprad(I)>99 THEN Storflytt=1
4550   RETURN 1
4560 FNEND
5000 ! *** Rotera: ***
5010 DEF FNRotera
5020   FOR I=0 TO 3
5030     IF Riktning=1 THEN Temprad(I)=Spelplan(I,C)
5040     IF Riktning=2 THEN Temprad(I)=Spelplan(C,I)
5050     IF Riktning=3 THEN Temprad(I)=Spelplan(3-I,C)
5060     IF Riktning=4 THEN Temprad(I)=Spelplan(C,3-I)
5070   NEXT I
5080   RETURN 0
5090 FNEND
6000 ! *** ]terst{ll rotation: ***
6010 DEF FN]terst{ll
6020   FOR I=0 TO 3
6030     IF Riktning=1 THEN Spelplan(I,C)=Temprad(I)
6040     IF Riktning=2 THEN Spelplan(C,I)=Temprad(I)
6050     IF Riktning=3 THEN Spelplan(3-I,C)=Temprad(I)
6060     IF Riktning=4 THEN Spelplan(C,3-I)=Temprad(I)
6070   NEXT I
6080   RETURN 0
6090 FNEND
7000 ! *** G|r drag: ***
7010 DEF FNDrag
7020   Flyttat=0
7040   FOR C=0 TO 3
7050     Z=FNRotera
7060     Z=FNFlytta
7070     Z=FNSl}Ihop
7080     Z=FNFlytta
7090     Z=FN]terst{ll
7100   NEXT C
7110   IF Flyttat>0 THEN Z=FNSlumpa
7130   Z=FNRitaspelplan
7150   RETURN 0
7160 FNEND
8000 ! *** Clear screen ***
8000 DEF FNClr
8010   ; CHR$(12)
8020   FGPOINT 0,0,0
8030   FGFILL 511,239
8040   RETURN 0
8050 FNEND
8499 ! *** Rita ram: ***
8500 DEF FNRam
8510   F{rg=1+2*RND
8520   FOR Y=4 TO 0 STEP -1
8530     FGPOINT 66,239-Y*40,F{rg
8540     FGLINE 450,239-Y*40,F{rg
8550   NEXT Y
8560   FOR X=1 TO 5
8570     FGPOINT 96*X-30,79,F{rg
8580     FGLINE 96*X-30,239,F{rg
8590   NEXT X
8600   RETURN 0
8610 FNEND
9000 Z=FNClr
9010 END